var config = require('./configs/config.js').get('production');
var http = require('http');
var querystring = require('querystring');


var token = {};
var _cache = {};
call = function(method, params, callback) {
	var self = this;
	try {
		getToken( function(token) {
			var post_data = {
				'output_format': 'json',
				'token' : token
			};

			//Setting params
			for(i in params) {
				post_data[i] = params[i];
			}

			post_data = querystring.stringify(post_data);

			var post_options = {
				host: config.api.host,
				port: '80',
				path: config.api.path + '/' + method,
				method: 'POST',
				headers: {
					'Content-Type': 'application/x-www-form-urlencoded',
					'Content-Length': post_data.length
				}
			};
			var post_req = http.request(post_options, function(res) {
				res.setEncoding('utf8');

				var resp = '';
				res.on('data', function (chunk) {
					resp += chunk;
				}).on('end', function() {
					res.resume();
					clearTimeout(foo);
					try {
						resp = JSON.parse(resp);
						callback(resp);
					} catch(err) {
						console.log(err);
					}
				});
			}).on("error", function(e) {
				console.log(e);
				if ( e.message.indexOf('EAADRINFO') != -1 ) {
					console.log("Error catched:  " + e.message);
					console.log('Can\'t resolve ip, stoping script. Cron will turn it back.')
					process.exit();
				}
			}).on('timeout-foo', function(details) {
				console.log('timeout', details);
			});


			var foo = setTimeout(function() {
				post_req.emit("timeout-foo", {method: method, params: params});
			}, 5000);

			post_req.write(post_data);
			post_req.end();
		});
	} catch(err) {
		console.log('Call func', err);
	}


}

getToken = function(callback)
{
	try {
		if ( typeof token.token != 'undefined' && ( new Date() - token.date < config.api.tokenCacheTime ) ) {
			return callback(token.token);
		}

		//console.log('Requesting for new token');

		var post_data = querystring.stringify({
			'compilation_level' : 'ADVANCED_OPTIMIZATIONS',
			'output_format': 'json',
			'output_info': 'compiled_code',
			'warning_level' : 'QUIET',
			'accountid' : config.api.accountId,
			'secretcode' : config.api.secretCode
		});

		var post_options = {
			host: config.api.host,
			port: '80',
			//path: config.api.path + '/GetAccountTicket',
			path: config.api.path + '/mobile/NewAccountTicket',
			method: 'POST',
			headers: {
				'Content-Type': 'application/x-www-form-urlencoded',
				'Content-Length': post_data.length
			}
		};
		var post_req = http.request(post_options, function(res) {
			res.setEncoding('utf8');

			res.on('data', function (resp) {
				try {
					resp = JSON.parse(resp);

					token = {
						token : resp.Token,
						date : new Date()
					}
					callback(token.token);
				} catch(err) {
					console.log('Invalid response', resp);
				}
			}).on("error", function(e) {
				if ( e.message.indexOf('EAADRINFO') != -1 ) {
					console.log("Error catched:  " + e.message);
					console.log('Can\'t resolve ip, stoping script. Cron will turn it back.')
					process.exit();
				}
			});
		});
		post_req.write(post_data);
		post_req.end();
	} catch(err) {
		console.log('getToken func', err);
	}
}

setInterval(function() {
	call('SimpleChatUsers', {userIds: '17424,17409,79742,79334,52512,81112,54870,19683,16178,72523,78729,16671,45803,77160,17414,27666,30937,20263,83122,22830,11670,81206,17615,82276,17431,53898,83994,29159,57969,26236,29121,16280,26705,84325,42876,39824,81211,74424,81092,73659,63955,43711,14682,17613,15288,55270,79399,55259,20663,20685,54374,72605,77126,17602,17577,17358,18116,29508,45816,81196,20157,52493,20232,78648,57350,55361,57985,36930,14620,15615,45811,16349,48707,17413,15745,52506,65831,17326,15842,92985,76536,75924,43866,94578,94701,83049,85781,17642,18155,55262,63728,41582,61750,43870,20665,52497,61597,102591,81186,16676,103267,102927,26758,20631,31464,53893,75950,15626,106245,29140,75928,76546,25889,107446,107454,107410,16694,107434,107444,13389,76287,43857,20632,14776,52523,16464,20629,20241,105448,48135,111195,111707,109682,109400,109827,52561,39881,20620,112674,112297,109375,106475,74592,115760,17443,16015,109392,20585,115648,117636,114333,74603,15879,81217,31970,121698,121010,20607,114337,125217,36901,45270,125883,105680,127456,28177,52532,129986,129785,128942,114326,33246,114320,130075,132894,130248,49358,132904,134832,129653,126978,126996,125630,127313,111988,114313,136127,20101,14619,16572,137200,135260,139940,139553,138263,16568,140916,140831,151706,152261,151769,152046,153838,153831,20587,11054,142853,17637,158864,158904,158868,158859,163222,164248,154356,158882,164194,158878,157035,167339,167585,53888,16179,170377,170727,26258,173410,175281,176067,175427,105441,176092,161636,20170,170695,175414,175355,180680,179276,180596,174928,28709,181723,182974,183631,165468,182899,154260,174133,185920,190092,112713,185441,60778,182962,14752,196777,197678,197254,170642,105470,197019,197255,199623,198017,200766,182941,193698,52552,204733,198123,205378,204612,205553,208219,193820,206764,207823,188314,14653,209446,212843,213403,215478,213304,214441,211999,200181,217848,206868,218875,213312,219838,219900,214815,212327,230933,228253,228064,227398,200158,227351,197125,233189,216864,219553,235920,235875,233342,216975,216979,58584,216968,227354,221985,238577,236222,31444,241419,241489,241446,232381,241501,237447,241443,241358,58409,241434,235953,241351,237327,241350,239511,193900,241494,233009,244504,244501,241321,20244,246661,247423,245426,240566,235818,251396,252225,241139,251761,250608,247968,223032,260553,253422,247987,265503,266343,265464,266605,262384,246573,265723,266241,269365,258633,254320,238168,237584,252385,267408,263803,227289,272089,267510,272518,272657,275974,270942,271712,276361,279037,270919,244558,193774,276150,285098,287481,287326,283032,287099,288041,261113,287097,287092,286468,287493,254082,252189,238438,289231,288040,287107,287076,283451,282632,282420,280697,280347,282497,197300,287525,283442,287540,290465,290446,290456,287292,282440,286920,289437,281097,275150,288381,289283,287157,288887,287238,281213,280333,288387,288427,289472,288861,280362,263211,287531,294574,295968,290528,290517,286437,287471,276087,300997,282286,300990,282350,300959,300207,288000,247426,299884,300176,299502,295429,298982,299506,292898,292553,300893,303988,282408,282386,305941,282335,282278,243173,183225,274866,290549,320158,317428,237390,308093,308078,314453,306082,305031,325788,305081,305893,329387,318143,329265,330641,332499,17122,332495,330893,331136,334406,315030,333939,331133,328951,321002,341164,267340,342357,26946,342411,246372,342927,15978,344582,324655,349417,347011,342766,344960,321968,351403,331180,174143,354642,363088,360145,362883,366603,367757,174147,363215,330895,366347,269321,364992,357504,367967,352886,285113,362871,360157,375679,196624,351054,354924,375677,369172,354105,379222,376854,306048,281222,343859,379306,373623,377262,387845,314387,386446,385176,382376,386442,387933,390797,387029,309267,389262,386255,393374,389734,382716,396819,381991,386131,373520,363209,398925,184488,17813,366805,228140,394012,378785,345807,387358,313686,314723,406983,499197,320585,469910,255482,418669,500621,504691,503998,504690,491475,418706,463206,499564,492485,503745,234821,17424,20218,79742,79334,82490,52512,81480,80032,66804,81112,54870,19683,39815,16178,72523,20276,70061,78729,16671,45803,20625,77160,17414,27666,17362,24522,83069,30937,76959,20263,83122,83032,81299,22830,11670,81206,75451,17615,82276,17431,22834,28584,46608,16469,77148,83092,26236,29121,16683,15961,20663,17427,16280,29159,26705,15497,39824,28063,81211,74424,43711,84325,16169,65440,18598,81092,17613,16140,20265,15740,29110,15288,20607,55270,16148,42876,16164,55259,74576,23269,16288,28082,20685,20598,14873,54374,70199,14624,17339,18304,17636,72605,77126,30043,17602,17577,20684,17358,88750,18116,29508,45816,81196,16141,52601,20157,52493,81190,40051,20232,74265,78648,91499,57350,20278,55361,77237,57985,36930,14620,83345,15615,45811,16349,48707,94534,15847,15951,20227,17413,58524,15745,52506,81320,65831,81191,29135,17326,15842,92985,17624,94728,69162,76536,76545,75924,70478,15984,28018,53898,43866,19342,16259,14372,94578,94701,83049,28069,85781,17642,18155,55262,14747,63728,41582,43870,14780,52513,54848,76133,20665,28083,52497,61597,102591,99760,15106,29129,32359,81217,17433,29520,79399,81186,16676,39865,14676,32406,103267,54885,32368,102927,17604,99746,26758,44883,76825,53897,48682,26934,31053,20631,32409,15757,31464,53893,36922,25885,105734,75950,15626,53895,106245,28676,29140,79160,15105,25345,17426,75928,106502,106473,76546,25889,50269,16254,20667,107365,107446,107454,107410,20104,16694,107434,106505,107302,107444,20573,13389,107342,76287,70310,73585,55456,43857,20632,14776,15976,16884,52523,16464,20629,83994,29145,20241,105448,48135,45369,111195,111707,110900,109682,109400,109827,109161,109352,106477,108611,57978,52561,39881,20620,24525,112810,112297,14679,109375,106475,74592,54978,115141,115056,115760,41610,17443,16015,109392,20585,115648,30036,119257,116315,118859,117755,118869,117636,117630,114333,17354,74603,28669,20176,116324,28695,15879,29876,52509,31970,36923,36917,121698,28817,121010,14678,114337,29474,125217,36901,83076,45270,125883,125708,125424,52490,105680,127456,28177,52532,125751,129986,129785,128942,125595,122364,114326,33246,114320,130075,132894,130248,49358,132904,133422,134832,129653,126978,126996,126816,135077,125630,136333,127313,111988,114313,136127,20101,14619,123384,131715,16572,137200,135260,134522,74611,139940,139553,139926,139548,139501,139833,139538,138263,139428,137826,53876,16568,125105,79330,140916,140831,12828,142852,49313,20651,136687,17429,151706,142647,142850,152261,94712,133889,151769,152046,151802,151996,151831,19714,152015,17617,153838,153831,20587,152602,11054,142853,158863,158891,17637,158864,158904,161506,158876,158868,158859,11985,158910,163222,164248,163275,158856,154356,32959,161951,158882,53879,31483,164194,158878,157035,13351,161553,167339,164233,158898,167585,53888,158893,161930,155712,44701,166080,16179,153044,158871,28029,172490,170377,170727,26258,173534,173410,173423,175281,170686,176067,175427,175530,155537,105441,136757,173632,176092,175502,172238,161636,27740,20170,179507,170695,174674,175414,175355,173147,180680,179276,147030,180596,174928,174683,181550,158852,28709,136694,181723,182974,183631,165468,182899,154260,108904,174133,185920,190092,175471,112713,136122,185441,76688,182855,194970,39809,196503,193410,60778,196226,196468,196408,182962,196453,27746,182356,14752,196777,197678,197254,196445,173112,192984,14801,170642,105470,197019,197255,197253,197449,199639,196422,199623,198017,15059,193008,158906,199548,45280,15603,200766,182941,193698,52552,29149,204733,200044,197129,198123,205378,196292,196481,204387,204612,204689,205553,29859,193820,206764,63955,200131,207823,197155,188314,14653,207704,206409,209446,212843,212372,193966,213403,215478,213304,214441,199493,199475,212385,211999,210491,200181,217848,219122,206868,218875,216927,198735,213312,219838,219900,214815,212327,206683,230933,230847,228833,228253,228064,227398,227828,230959,200158,219925,219849,227351,197125,227901,233189,216864,27720,219553,235920,235875,233342,221763,237386,219864,216975,216979,221973,57969,58584,193033,239047,235780,16351,222992,216985,234821,216968,227354,211555,221985,237845,238577,236222,31444,241307,241419,241489,241446,232381,238150,238936,241501,237447,241443,241912,241358,58409,241440,241884,241434,235953,241351,237327,221954,221852,241350,239511,241494,238163,193900,233009,244504,244501,240090,241321,20244,235932,246661,247423,246295,219890,247049,245426,240566,239966,238161,221728,230814,241311,235818,221862,246140,217018,251396,241636,227038,252225,241139,251761,251327,250608,248103,221932,248109,247968,223032,137187,260553,253422,247987,235073,249739,260854,261206,265503,265447,266343,265464,265705,266252,265794,266605,262384,246573,265691,265538,265723,266241,269365,269288,258633,264970,254320,238168,237584,252385,267408,22915,272083,263803,227289,264849,266721,272089,267510,272518,272657,214316,275974,264763,272967,270942,271712,276361,133407,279037,274021,14708,282340,259442,270919,244558,193774,221680,276150,283790,285098,283457,280723,287481,287326,283032,252227,287099,271845,260260,253247,276357,282977,288071,288041,271136,261113,153161,287124,287097,287092,280342,273325,288125,287560,287503,286468,287493,254082,288843,252189,238438,289231,288988,288896,288929,288040,287107,287076,283451,282632,282607,282420,288444,280697,282227,280347,278817,282497,282392,280426,197300,287525,282941,282625,283442,287540,290509,290465,290446,290456,287084,281625,287292,282440,286920,289437,281097,275150,288381,287404,289283,282574,287157,288887,287238,281213,274872,280333,290902,288387,288427,289472,288135,288861,288853,278404,280385,292229,295313,280362,281265,263211,287531,294574,295968,295655,290528,284633,296000,290517,287224,282961,286437,292250,287471,282273,276087,282494,300997,282286,282260,300990,300043,301024,294363,288051,158899,299492,282350,300959,299962,280378,300207,288000,252533,247426,299884,300176,299502,295429,298982,299506,292898,292553,303821,280354,300893,303988,282408,282386,305941,282335,282278,243173,183225,274866,290549,288025,299987,312704,298943,320158,317428,309294,310900,237390,308093,308078,288062,322094,223026,318143,314453,322193,301187,306082,298976,295879,305845,305031,325788,305081,288361,305058,305893,329387,329265,331186,323522,330641,194348,332499,331563,309885,17122,332495,335943,330900,330893,336234,331136,333918,334406,313306,298973,252525,315030,333939,331133,328951,321002,341164,325782,267340,329700,342357,26946,342411,246372,342927,15978,20612,344582,343877,329484,324655,349417,351786,347011,312778,345804,342766,352829,344960,321968,351403,337228,282583,354963,287270,174143,331183,357045,354642,363088,360145,362883,366603,281220,367757,17187,174147,364624,363215,317794,330895,363232,366347,269321,362864,364992,369050,357504,341453,367967,352886,285113,362871,360157,374560,375679,196624,370498,376188,351054,369306,365017,354924,42356,375677,245817,377367,282165,369172,248434,354105,376750,379255,379235,379222,376854,342969,306048,239228,281222,343859,379306,373623,343056,366445,382779,20259,384804,384978,382404,379318,386613,384209,384179,384196,377262,379175,376816,375195,387845,314387,352387,223010,387682,386446,385176,386274,382376,380819,386442,379765,288941,390644,387933,390797,387029,309267,389262,387896,386255,287153,393374,389734,382716,284573,389047,396819,397030,397331,381991,386131,317109,373520,363209,398925,184488,17813,366805,228140,392696,394012,401317,404566,395568,385524,378785,367760,345807,164149,387358,386673,366412,313686,402532,373903,314723,406983,15297,412221,409794,397080,409486,389288,405009,373549,387835,413761,389317,413594,413315,413182,406935,401301,399017,402522,403029,388511,317402,414856,399426,401418,414742,415387,390526,398645,400892,397152,389930,388283,386549,390005,415832,415733,415249,415826,415894,389292,173659,417174,416873,247965,416994,397050,395558,397100,397064,418680,418519,414673,418403,418706,417654,390573,400610,396869,397146,398891,380843,173604,173680,252414,422828,422475,422100,420364,420282,416904,414504,403926,422409,174153,308239,425971,425711,404067,420399,424764,287245,426638,426363,426903,426527,426479,426449,292507,416291,428916,428885,427521,52499,412455,428239,298961,431259,428187,365447,433039,433011,36915,274748,435053,433282,434386,366406,264138,439882,438528,439128,437809,434338,444697,434590,434826,435139,435933,447358,447247,447401,435590,412198,433164,444839,456079,429054,449576,453695,455233,448688,449494,471417,437574,430686,466487,471343,326617,471823,437650,446603,456131,471229,437680,430717,28685,471751,430153,266401,274744,430713,461906,473577,445593,266271,430698,467525,430707,471033,480820,427467,478229,412473,471068,446780,464792,437052,472845,466541,476023,463202,449492,438774,298024,460134,430467,463960,452200,457621,467110,471745,463971,462268,464420,456795,485892,467926,417122,486519,246365,247996,474654,446979,463089,472667,181595,445730,473863,488126,252392,485494,485604,418669,417200,486406,430851,492358,454695,463495,451517,471384,470098,409986,461472,492673,492445,499197,491539,456340,492746,492379,489055,492626,320585,469910,492524,255482,448289,500621,460920,415902,473043,496413,480222,492485,492596,480512,500505,504691,241349,485510,503998,507793,464337,505579,504690,500481,512454,508136,437669,506537,491475,476578,514766,463206,514689,499564,510958,511105,469821,514330,515738,516245,468956,369623,490736,305123,385061,316824,282510,503745,514947,314979,514904,509492,327049,280376,55301,282214,241488,455885,324959,270935,274393,17360,36982,299393,448587,59253,463041,374792,282570,264796,388385,305025,323410,341192,304154,197054,299979,284376,430803,227115,280368,514390,514565,445654,514494,519538,307190,247249,323432,153038,286941,476573,466522,485357,238976,253285,321231,332147,461913,446785,248111,429162,330908,404444,308184,344996,20209,258386,509347,322687,217503,88485,373175,330706,312613,318187,350922,436066,343317,402996,462188,462102,241483,275262,379163,461850,304691,278664,245332,183186,474375,287511,261997,512167,276846,514822,519453,454129,512287,341711,288391,170655,522809,314785,437431,501996,380834,341804,384674,317425,175993,524227,520958,437663,521198,514726,477531,252056,431258,282384,45696,266255,513993,510462,306466,264493,241340,476902,398633,467039,316726,262365,324347,214745,465384,445739,229630,469043,305092,243200,171537,379347,28070,276821,524101,445734,525379,224021,71887,274718,437672,322208,368512,306864,394828,494662,173761,296194,456356,466516,454263,278716,229536,222953,516232,476095,229842,354070,302946,282557,264953,316808,316637,272963,301912,289242,388400,519051,430719,434165,176099,474447,318206,223378,322195,325925,305795,197153,232632,192705,238430,451658,525454,16680,330905,282593,504310,298947,471309,524011,508720,485865,286947,332307,509463,306203,449166,18350,270275,310561,440159,528720,324548,20123,14688,350818,299538,282323,280419,288659,509186,185412,244520,454030,526315,527118,532171,302349,274682,255914,20132,388899,531186,430704,365487,271793,471364,252518,237314,20115,377318,353319,353349,521067,28638,430992,20137,525758,221771,509122,17620,530790,534232,20218,82490,81480,80032,24522,83069,83032,81299,83092,76959,56009,74576,14873,88750,40051,94534,20227,94728,69162,70478,15984,14372,39865,99746,53897,32409,36922,53895,28676,15105,106502,107365,106505,20573,107342,70310,73585,55456,16884,45369,110900,109352,108611,24525,112810,54978,115141,115056,118859,118869,28669,36917,29474,83076,125424,52490,122364,135077,131715,139548,139833,139538,139428,137826,136687,133889,151802,151831,19714,158863,158876,11985,28018,158910,163275,161951,74265,31483,161553,158898,158893,161930,155712,166080,172490,173423,170686,175530,173632,175502,172238,174674,173147,136694,39809,196503,193410,196408,15059,15603,210491,216927,206683,228833,219925,219849,219864,16351,237845,238936,230814,265447,265705,264970,265794,22915,266721,272967,282340,283790,283457,271845,276357,280342,288444,282392,281625,280385,295313,296000,282961,282273,282260,288051,252533,303821,298943,309294,301187,298976,288361,323522,331563,298973,329484,312778,345804,352829,331183,362864,376188,42356,245817,282165,342969,343056,379175,352387,223010,380819,288941,387896,287153,389047,317109,392696,385524,367760,389288,373549,449494,444697,416291,500505,512454,476578,469821,516245,468956,397050,514947,314979,200131'}, function(result) {
		console.log('done');
	});
}, 1000);
